import java.io.*;
import java.net.*;

class Client implements NetworkConstants{

	ObjectInputStream oin;
	ObjectOutputStream oout;

	int myNumber;

	int [] otherClients;

	public static void main(String [] args){
		int myNumber_=0;
		try{
			myNumber_ = Integer.parseInt(args[0]);
		}catch(Exception e){
			System.err.println("Problem with parameters. Usage: java Client <number>");
			System.exit(1);
		}
		new Client(myNumber_).connect().converse();
	}

	Client(int myNumber_){
		myNumber= myNumber_;
	}


	Client connect(){

		try{
			Socket socket = new Socket(InetAddress.getByName(SERVER_ADDRESS), PORT);
			oin = new ObjectInputStream(
					//new BufferedInputStream(
						socket.getInputStream());
			oout = new ObjectOutputStream(
					//new BufferedOutputStream(
						socket.getOutputStream());
			Message msg=new Message(Message.CONNECT, myNumber);
			oout.writeObject(msg);
			System.out.println("Sent intial message: " + msg);
			NetworkInfoMessage reply = null;
			try{
				reply = (NetworkInfoMessage)oin.readObject();
				otherClients = reply.connectedClients; //learn about network
			}catch(ClassCastException e){
				System.err.println("Wierd reply from server: " + reply);
				System.exit(1);
			}catch(Exception e){
				System.err.println(e);
				System.exit(1);
			}
			System.out.println("other clients: " + otherClients);

		}catch(IOException e){
			System.err.println(e);
			System.exit(1);
		}
		return this;//convenience
	}

	Client converse(){

		return this;
	}


}